/*  -*- Mode: C -*-
 * ------------------------------------------------------------------
 * DO NOT EDIT THIS FILE!  It has been automatically generated.
 * ------------------------------------------------------------------
 */

#ifndef QTHREAD_COMMON_H
#define QTHREAD_COMMON_H

#ifndef __powerpc
#define BITFIELD_ORDER_REVERSE
#else
// ARM processors can technically change modes between
// big-endian and little-endian which also reverses the
// bitfield order. The overwhelming majority of the time
// they're run in little-endian mode though.
#define BITFIELD_ORDER_FORWARD
#endif

#ifdef __cplusplus
#ifdef __GNUC__
#define restrict __restrict
#else
#define restrict
#endif
#endif

#ifdef __GNUC__
#define QTHREAD_TRAP() __builtin_trap()
#else
#include "signal.h"
#define QTHREAD_TRAP() raise(SIGABRT)
#endif

/* Architecture defines */
#define QTHREAD_UNSUPPORTED 0
#define QTHREAD_IA32 1
#define QTHREAD_AMD64 2
#define QTHREAD_POWERPC32 6
#define QTHREAD_POWERPC64 7
#define QTHREAD_ARM 12
#define QTHREAD_ARMV8_A64 13

#if defined(__amd64__) || defined(_M_AMD_64)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_AMD64
#elif defined(__aarch64__) || defined(_M_ARM64)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_ARMV8_A64
#elif defined(_ARCH_PPC64)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_POWERPC64
#elif defined(__i386__) || defined(_X86_) || defined(_M_IX86)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_IA32
#elif defined(__arm__) || defined(_M_ARM)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_ARM
#elif defined(_ARCHPPC)
#define QTHREAD_ASSEMBLY_ARCH QTHREAD_POWERPC32
#else
#error "Unsupported architecture"
#endif

#endif
